inlets=5;
outlets=2;

var boolEnabled = 0;	// This boolean begins as off. Once we switch on the device it flips to make sure we won't fire this animal more than once.
var lAPI;
var i;
var lapiCurrentClip;
var lapiCurrentClipVolume;
var lapiNextClip;
var lapiNextClipVolume;
var intDeckOverride = 4;
var dblPercentageComplete;


var dblTransitionPoint = .75;
var dblTransitionLength = 32;

function bang() {
	switch(inlet) {
		case 0:
			break;
		case 1:
			init();
			break;
		case 2:
			if (boolEnabled) {
				Stop();
			}
			break;
		default:
			post("bang() Default reached. Breaking.\n");
			break;
	}
}


// Init (only run once upon initial start)
function init() {

	// Instantiation
	lAPI = new LiveAPI();
	lapiCurrentClip = new LiveAPI(CurrentCallback);
	lapiNextClip = new LiveAPI(NextCallback);
	lapiCurrentClipVolume = new LiveAPI();	
	lapiNextClipVolume = new LiveAPI();

	// Set the global quantize to 1 bar for better beat matching.
	lAPI.path = "live_set";
	lAPI.set("clip_trigger_quantization", 4);

	// Party time
	if (!boolEnabled) {
		Go();
	}
}

// function Go()
// Captures the current playing clip, assigns callback, assigns next cip to play.
// This is the function that gets called repeatedly after the initial init() call.

function Go() {	
	
	if (GetDeckCount() && SetPlayingClipID() && SetNextClipID()) {
		post("Current Clip and Next Clip Discovered. Autopilot is go.\n");
		post("Transition Marker at: " + (lapiCurrentClip.TransitionMarker / 4) + "\n");
		outlet(1, "set", "On. Next Track Ready.");
		lapiCurrentClip.property = "playing_position";
		boolEnabled = 1;
	} else {
		post("Only one deck, no current playing clip or no next clip. Stopping autopilot.\n");
		Stop();
	}
		
}

// function Stop()
// Stops the loop. Destructs objects. Garbage collecting and housekeeping.

function Stop() {
	// Reset the global quantize...
	//lAPI.path = "live_set";
	//lAPI.set("clip_trigger_quantization", 9);
	
	lapiCurrentClip.id = 0;
	lapiCurrentClipVolume.id = 0;
	lapiNextClip.id = 0;
	lapiNextClipVolume.id = 0;
	lAPI.id = 0;
	boolEnabled = 0;
	post("All objects and variables destructed. Autopilot stopped.\n");
	outlet(1, "set", "Off.");
}

// function CurrentCallback()
// Listens to the property updates of playing position. Determines when to fire the next clip
// and how to make that transition.

function CurrentCallback(args) {
	switch(args[0]) {
 		case "playing_position":
			// Check for hitting the transition point and start crossfading!
			if (args[1] >= lapiCurrentClip.TransitionMarker) {
				post("CurrentClip Transition Point Met!\n");

				lapiNextClip.call("fire");
				lapiCurrentClip.property = 0;	// End listening to the current clip's playing position
				lapiNextClip.property = "playing_position";	// Begin listening to the next clip's playing position
				
				outlet(0, (args[1] - this.TransitionMarker));
			}
			break;
		default:
			break;
	}
}


// function NextCallback()
// Listens to the property updates on the _next_ track's playing position. This handles the actual crossfade.

function NextCallback(args) {
	switch(args[0]) {
		case "playing_position":
			// WHAT THE FUCKING FUCK FUCK!!!
			// These following three lines took me three hours to come up with. Live, upon firing a clip, sets "playing_position"
			// to 0 for all but the briefest of moments. In the case of clips with negative "start_marker" values this really
			// fucks up how my callbacks work. Fixes things. What the fuck.
			if(args[1] == 0) {	// Fuck
				break;			// my
			} else {			// life.
				outlet(0, (args[1] - this.StartMarker));
				break;
			}
		default:
			break;
	}
	
}




// function msg_float()
// In JS you cannot update anything based on property updated callbacks. Here we are pushing our updates
// through the MFL device "deferlow" to acheive this. It is piped back in here at "msg_float" where we
// actually update volume tracks.
//
// This is where the rubber meets the road. Here we handle killing the old clip, crossfading, etc.

function msg_float() {
	var dblNextVolume = 0;

	switch(inlet) {
		case 0:
			// Calculate out perecentage of calculation to make things easier below.
			dblPercentageComplete = (arrayfromargs(arguments) / dblTransitionLength).toFixed(4);
			
			// Calculate/Store the NextClip volume here
			dblNextVolume = .84 * dblPercentageComplete;

			// Error check for funny volume amounts...a function of Live doing strange things with "playing_position"
			if (dblNextVolume < 0 || dblNextVolume > .85) {
				post("Invalid volume amount: " + dblNextVolume + "\n");
				break;
			}

			// Adjust the outgoing track by the inverse of the incoming track's volume. It's the percentage calculated above.
			lapiCurrentClipVolume.set("value", .85 - dblNextVolume);
			lapiNextClipVolume.set("value", dblNextVolume);

			// This fixes things such that the program has an easier time running perpetually. Just gotta kill the outgoing
			// clip a little sooner to account for large quantizations.
			if (dblPercentageComplete > .80) {
				lapiCurrentClip.call("stop");
			}

			// At 97% we call it quits. Wipe out the volume on the outgoing track, 100% volume on the new track, and 
			// run the program again.
			if (dblPercentageComplete > .97) { 
				lapiCurrentClipVolume.set("value", 0);	// Kill the "out" clip volume.
				lapiNextClipVolume.set("value", .85);	// Set the "in" clip volume.
				Stop();	// Destruct objects
				Go();	// Call Go() again
			}
			break;
		case 3:
			dblTransitionPoint = (arrayfromargs(arguments) / 100);
			post("Transition Point: " + dblTransitionPoint + "\n");
			break;
		case 4:
			dblTransitionLength = arrayfromargs(arguments);
			post("Transition Length: " + dblTransitionLength + "\n");
			break;
		default:
			break;
	}
}


// function SetPlayingClipID()
// Returns LOM ID of first discovered playing track (left to right)
// Returns a -1 if none found

function SetPlayingClipID() {
	var intReturnValue = 0;
	var intDeckCount = 0;
	
	intDeckCount = GetDeckCount();
	
	for (i = 0; i < intDeckCount; i++) {
		lAPI.path = "live_set tracks " + i;
		if (lAPI.get("playing_slot_index") >= 0) {
			lapiCurrentClip.path = "live_set tracks " + i + " clip_slots " + lAPI.get("playing_slot_index") + " clip";
			lapiCurrentClip.Deck = i;
			lapiCurrentClip.Length = parseInt(lapiCurrentClip.get("length"), 10);
			lapiCurrentClip.StartMarker = parseInt(lapiCurrentClip.get("start_marker"), 10);
			lapiCurrentClip.EndMarker = lapiCurrentClip.StartMarker + lapiCurrentClip.Length;
			post("lapiCurrentClip End Marker: " + (lapiCurrentClip.EndMarker / 4) + "\n");
			lapiCurrentClip.ClipSlot = lAPI.get("playing_slot_index");
			lapiCurrentClip.TransitionMarker = lapiCurrentClip.StartMarker + (lapiCurrentClip.Length * dblTransitionPoint);

			// Check to make sure the transition length isn't going to run past the end of the first track...
			if ((lapiCurrentClip.TransitionMarker + dblTransitionLength) >= lapiCurrentClip.EndMarker) {
				//...if so, then let's cut the transition length to the very end of the track.
				dblTransitionLength = lapiCurrentClip.EndMarker - lapiCurrentClip.TransitionMarker;
				post("Not enough length left in the first track to accomodate the transition length. Shortened transition length to fit.\n");
			}

			lapiCurrentClipVolume.path = "live_set tracks " + i + " mixer_device volume";	// Set volume for the playing track

			post("Current Clip Set: " + lapiCurrentClip.get("name") + "\n");
			intReturnValue = 1;
			break;
		}
	}

	lAPI.id = 0;
	
	return intReturnValue;
}


// function SetNextClipID()
// Returns LOM ID of first discovered playing track to the immediate right of
// the current playing track. This is a simple method of steering that could
// perhaps use some improvement, but for what it's worth, functions just fine.
// This tool is all about convenience in a pinch and nothing too dramatic.

function SetNextClipID() {
	var intReturnValue = 0;
	var intDeckCount = 0;
	
	intDeckCount = GetDeckCount();
	lapiNextClip.id = 0;

	// Ensure we have a current clip playing
	if (lapiCurrentClip.id == 0) { 
		return intReturnValue;
	} 
	
	// Steering. Read like a book going left to right and top to bottom.
	if ((lapiCurrentClip.Deck + 1) == intDeckCount) {	// Check to see if we are at the last deck
		lapiNextClip.Deck = 0;	// Goto the first deck...
		lapiNextClip.ClipSlot = parseInt(lapiCurrentClip.ClipSlot, 10) + 1;	// ...and assign the next clip slot down. Like reading a book!
	} else {
		lapiNextClip.Deck = parseInt(lapiCurrentClip.Deck, 10) + 1;	// Why the hell do I have to parseInt on this? *sigh*
		lapiNextClip.ClipSlot = lapiCurrentClip.ClipSlot;
	}
	
	lapiNextClip.path = "live_set tracks " + lapiNextClip.Deck + " clip_slots " + lapiNextClip.ClipSlot;
	
	// Check to see if there is actually a clip in the next clip slot...
	if (lapiNextClip.get("has_clip") == 1) {
		//...if so, then proceed in setting the next clip.
		intReturnValue = 1;
		lapiNextClip.path = "live_set tracks " + lapiNextClip.Deck + " clip_slots " + lapiNextClip.ClipSlot + " clip";
		lapiNextClip.Length = parseInt(lapiNextClip.get("length"), 10);
		lapiNextClip.StartMarker = parseInt(lapiNextClip.get("start_marker"), 10);
		lapiNextClip.EndMarker = lapiNextClip.StartMarker + lapiNextClip.Length;
		post("lapiNextClip End Marker: " + (lapiNextClip.EndMarker / 4) + "\n");
		lapiNextClip.TransitionMarker = lapiNextClip.StartMarker + (lapiNextClip.Length * dblTransitionPoint);
		
		// Similar to the lapiCurrentClip section above, check to see if there is enough length for the transition...
		if (dblTransitionLength >= lapiNextClip.TransitionMarker - lapiNextClip.StartMarker) {
			//...if there is now not enough space to transition into the next track such that the function starts over leaving room for the
			//_new_ transition point, we need to chop down the dblTransitionLength further
			dblTransitionLength = (parseInt(lapiNextClip.get("length"), 10) * dblTransitionPoint);
			post("NextClip didn't have enough length to afford the transition length while leaving room to hit the new transition point fluidly. Reducing dblTransitionLength.\n");
		}
		
		lapiNextClipVolume.path = "live_set tracks " + lapiNextClip.Deck + " mixer_device volume";	// Set volume for the next track
		post("Next Clip Set: " + lapiNextClip.get("name") + "\n");
	}
	
	return intReturnValue;
	
}

// function GetDeckCount()
// Returns number of decks on the current project.

function GetDeckCount() {
	var intReturnValue = 0;
	lAPI.path = "live_set tracks";
	intReturnValue = lAPI.children[0];

	lAPI.id = 0
	
	if (intDeckOverride != 0) {
		return intDeckOverride;
	} else {
		return intReturnValue;
	}
}

